"""
 Princeton University, COS 429, Fall 2020
"""
import numpy as np


def find_faces_single_scale(img, stride, thresh, params, orientations, wrap180):
    """Find 36x36 faces in an image

    Args:
        img: an image
        stride: how far to move between locations at which the detector is run
        thresh: probability threshold for calling a detection a face
        params: trained face classifier parameters
        orientations: the number of HoG gradient orientations to use
        wrap180: if true, the HoG orientations cover 180 degrees, else 360

    Returns:
        outimg: copy of img with face locations marked
        probmap: probability map of face detections
    """
    windowsize = 36
    if stride > windowsize:
        stride = windowsize

    height, width = img.shape
    probmap = np.zeros([height, width])
    outimg = np.array(img)

    # Loop over windowsize x windowsize windows, advancing by stride
    # Fill in here
    # for i in ...
        # for j in ...

            # Crop out a windowsize x windowsize window starting at (i,j)
            # crop = 

            # Compute a HoG descriptor, and run the classifier
            # ...
            # probability = ...

            # Mark detection probability in probmap
            win_i = i + int((windowsize - stride) / 2)
            win_j = j + int((windowsize - stride) / 2)
            probmap[win_i:win_i+stride, win_j:win_j+stride] = probability

            # If probability of a face is below thresh, continue
            if probability < thresh:
                continue

            # Mark the face in outimg
            outimg[i, j:j+windowsize] = 255
            outimg[i+windowsize-1, j:j+windowsize] = 255
            outimg[i:i+windowsize, j] = 255
            outimg[i:i+windowsize, j+windowsize-1] = 255

    return outimg, probmap
